package wiley.streaming.curator;

import java.util.Random;

import org.apache.curator.framework.CuratorFramework;
import org.apache.curator.framework.CuratorFrameworkFactory;
import org.apache.curator.framework.recipes.queue.DistributedQueue;
import org.apache.curator.framework.recipes.queue.QueueBuilder;
import org.apache.curator.retry.RetryOneTime;

public class DistributedQueueProducer implements Runnable {

	DistributedQueue<WorkUnit> queue;
	
	
	public DistributedQueueProducer(String connectString) throws Exception {
		CuratorFramework client = CuratorFrameworkFactory.newClient(connectString, new RetryOneTime(10));
		client.start();

		queue = QueueBuilder.builder(client, 
				null, 
				new SimpleSerializer<WorkUnit>(), 
				"/queues/work-unit")
		.buildQueue();
		queue.start();
		
	}
	
	
	Random rng = new Random();
	public void run() {
		System.out.println("Starting Producer");
		boolean cont = true;
		long id = 0;
		while(cont) {
			try {
				queue.put(new WorkUnit(id++,"Next Work Unit "+id));
				System.out.println("Added item");
			} catch (Exception e1) {
				e1.printStackTrace();
			}
			try {
				Thread.sleep(rng.nextInt(1000));
			} catch (InterruptedException e) {
				cont = false;
			}
		}
	}

}
