package wiley.streaming.curator;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import org.apache.curator.framework.recipes.queue.QueueSerializer;

public class SimpleSerializer<T extends Serializable> implements
		QueueSerializer<T> {

	public byte[] serialize(T item) {
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		byte[] value = null;
		try {
			ObjectOutput          out = new ObjectOutputStream(bos);
			out.writeObject(item);
			value = bos.toByteArray();
			out.close();
		} catch(IOException e) { }
		try {
			bos.close();
		} catch(IOException e) { }
		return value;
	}

	@SuppressWarnings("unchecked")
	public T deserialize(byte[] bytes) {
		ByteArrayInputStream bin = new ByteArrayInputStream(bytes);
		Object object = null;
		try {
			ObjectInput          in  = new ObjectInputStream(bin);
			object = in.readObject();
			in.close();
		} catch(IOException e) {
		} catch (ClassNotFoundException e) {
		} 
		try {
			bin.close();
		} catch(IOException e2) { }
		return (T)object;
	}

}
