package wiley.streaming.camus;

import java.io.IOException;

import org.codehaus.jackson.map.ObjectMapper;
import org.codehaus.jackson.node.ObjectNode;

import com.linkedin.camus.coders.CamusWrapper;
import com.linkedin.camus.coders.MessageDecoder;
import com.linkedin.camus.coders.MessageDecoderException;

public class JSONMessageDecoder extends MessageDecoder<byte[], ObjectNode> {

	private final ObjectMapper mapper = new ObjectMapper();
	
	@Override
	public CamusWrapper<ObjectNode> decode(byte[] arg0) {
		ObjectNode json;
		try {
			json = mapper.readValue(new String(arg0), ObjectNode.class);
		} catch (IOException e) {
			throw new MessageDecoderException("Unable to parse event");
		}
		return new CamusWrapper<ObjectNode>(json,json.get("ts").getValueAsLong());
	}

}
