package wiley.streaming.forecast;

public class AdditiveForecast extends SeasonalForecast {

	public AdditiveForecast(double level, double trend, double a, double b,
			double[] s, double g) {
		super(level, trend, a, b, s, g);
	}

	@Override
	public double forecast(double x) {
		int h = (t + (int)Math.floor(x-1.0)) % s.length;
		return super.forecast(x) + s[h];
	}

	@Override
	public double update(double y) {
		double e = super.update(y);
		
		s[t] = s[t] + g*(1-a)*e;
		t = (t + 1) % s.length;
		
		return e;
	}
	
	

}
