package wiley.streaming.forecast;

public class HoltForecast {
	double level = 0;
	public double level() { return level; }
	double trend = 0;
	public double trend() { return trend; }

	double a = 0.0;
	double b = 0.0;
	
	public HoltForecast(double level,double trend,double a,double b) {
		this.level = level;
		this.trend = trend;
		this.a     = a;
		this.b     = b;
	}
	public HoltForecast(double level,double trend) {
		this(level,trend,0.2,0.8);
	}
	public double error(double y) { return y - forecast(1.0); }
	
	public double update(double y) {
		double e = error(y);
		level = level + trend + a*e;
		trend = trend + a*b*e;
		return e;
	}
	
	public double forecast(double x) {
		return level + trend*x;
	}

	
}
