package wiley.streaming.ols;

public class LogisticRegression {

	double[] B;

	public LogisticRegression(double[] B) {
		this.B = B;
	}
	
	public double y(double[] x) {
		double y = 0;
		for(int i=0;i<B.length;i++) y += B[i]*x[i];
		return logit(y);
	}
	
	public static double invlogit(double p) {
		return Math.log(p/(1-p));
	}

	public static double logit(double y) {
		return 1.0/(1.0 + Math.exp(-y));
	}
	
	public LogisticRegression initialize(int k,double alpha) {
		B = new double[k];
		return this;
	}
	
	int MAX_ITER = 1000;
	double alpha = 0.2;
	public LogisticRegression fit(double[][] x,double[] y) {
		//Initialize the weights
		B = new double[x[0].length];
		double lastError = Double.POSITIVE_INFINITY;
		for(int iter=0;iter<MAX_ITER;iter++) {
			double err2 = 0;
			for(int i=0;i<x.length;i++) {
				double t = y[i] - y(x[i]);
				for(int j=0;j<x[i].length;i++)
					B[j] += alpha*t*x[i][j];
				err2 += t*t;
			}
			err2 = Math.sqrt(err2);
			if(err2 - lastError < 1e-6) break;
			lastError = err2;
		}
		return this;
	}
	
	
	
}
