package wiley.streaming.optimizer;

import wiley.realtime.sampler.Distribution;

public class BernoulliThompson {
	
	double[] n;
	double[] x;
	
	public BernoulliThompson(int classes) {
		n = new double[classes];
		x = new double[classes];
	}
	
	public void expose(int k) {
		if(k < n.length)
			n[k] += 1.0;
	}
	
	public void success(int k) {
		if(k < x.length) x[k] += 1.0;
	}
	
	Distribution d = new Distribution();	
	public int choose() {
		int    max = -1;
		double mu = Double.NEGATIVE_INFINITY;
		for(int i=0;i<x.length;i++) {
			double alpha = 1.0 + x[i];
			double beta  = 1.0 + (n[i] - x[i]);
			double x = d.nextBeta(alpha,beta);
			if(x > mu) {
				max = i;
				mu  = x;
			}
			
		}
		return max;
	}
	
	
	
}
