package wiley.streaming.ts;

public class WeightedMovingAverage {
	double[] kernel;
	double[] values;
	double   kernelSum = 0.0;
	int      k = 0;
	long     N = 0;
	
	public WeightedMovingAverage(double[] kernel) {
		this.kernel = kernel;
		for(double j : kernel) kernelSum += j;
		values = new double[kernel.length];
	}
	
	public double observe(double x) {
		values[k++] = x;
		if(k == values.length) k = 0;
		N++;
		if(N < kernel.length) return Double.NaN;

		double y = 0;
		for(int i=0;i<kernel.length;i++) 
			y += kernel[i]*values[(k+i) % values.length];
		return y/kernelSum;
	}
}
