package wiley.streaming.forecast;

import static org.junit.Assert.*;

import org.junit.Test;


public class HoltWintersTest {

	double[] y = {41.7,24,32.3,37.3,46.2,29.3,36.5,43,48.9,31.2,37.7,40.4,51.2,31.9,41,43.8,55.6,33.9,42.1,45.6,59.8,35.2,44.3,47.9};
	
	
	
	@Test
	public void additive() {
		System.out.println("Additive");
		double[] s0 = {10.3,-9.9,-2.4,1};
		SeasonalForecast seasonal = new AdditiveForecast(33.6,0.6,0.2,0.8,s0,0.8);
		System.out.println("h\ty\tl\tb\ts\tf");
		for(int i=0;i<y.length;i++) {
			double err = seasonal.update(y[i]);
			System.out.println(
					String.format("%d\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f", i+1,y[i],seasonal.level(),seasonal.trend(),seasonal.seasonal(),y[i]-err)
			);
		}
		for(int i=1;i<8;i++) {
			System.out.println(
					String.format("%d\t\t%.1f\t%.1f\t%.1f\t%.1f", i+24,seasonal.level(),seasonal.trend(),seasonal.seasonal(i),seasonal.forecast(i))
			);
			
		}
	}

	@Test
	public void multiplicative() {
		System.out.println("Multiplicative");
		double[] s0 = {1.221,0.7,0.9,1};
		SeasonalForecast seasonal = new MultiplicativeForecast(34.6,0.6,0.2,0.8,s0,0.8);
		System.out.println("h\ty\tl\tb\ts\tf");
		for(int i=0;i<y.length;i++) {
			double err = seasonal.update(y[i]);
			System.out.println(
					String.format("%d\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f", i+1,y[i],seasonal.level(),seasonal.trend(),seasonal.seasonal(),y[i]-err)
			);
		}
		for(int i=1;i<8;i++) {
			System.out.println(
					String.format("%d\t\t%.1f\t%.1f\t%.1f\t%.1f", i+24,seasonal.level(),seasonal.trend(),seasonal.seasonal(i),seasonal.forecast(i))
			);
			
		}
	}
	
	
}
