package wiley.aggregation;

import java.util.ArrayList;

public class Aggregator {
	
	ArrayList<Aggregate> aggregates = new ArrayList<Aggregate>();
	public Aggregator aggregate(Aggregate e) { 
		aggregates.add(e);
		return this;
	}
	
	Expirer expirer = null;
	public Aggregator expirer(Expirer expirer) {
		this.expirer = expirer;
		return this;
	}
	
	Notifier notifier = null;
	public Aggregator notifier(Notifier notifier) {
		this.notifier = notifier;
		return this;
	}
			
	
	public <E> void each(long timestamp,String key,E value,Command<E> cmd) {
		for(Aggregate a : aggregates) {
			long   quantized = a.quantize(timestamp);
			String quantizedString = a.quantizeString(timestamp);
			String expireKey = cmd.execute(timestamp,quantized,quantizedString,key, value);
			if(expireKey != null && expirer != null) {
				expirer.expire(expireKey, a.expire(timestamp));
			}
			if(notifier != null) {
				notifier.notify(key,a.resolutionString(),timestamp,quantized,quantizedString);
			}
			
		}
	}
	
	public <E> void each(String key,E value,Command<E> cmd) {
		each(System.currentTimeMillis(),key,value,cmd);
	}
	
	
}
