package wiley.realtime;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.BitSet;
import java.util.Collection;
import java.util.Map;
import java.util.Set;

import wiley.realtime.hash.SerializableHasher;

public class CountMinSketch<E extends Serializable> implements Map<E,Long> {

	int width = 0;
	int depth = 0;
	int[]  m;
	
	SerializableHasher[] hashes;
	ObjectOutputStream[] outputs;
	
	protected void initialize(int m,int[] seeds) throws IOException {
		hashes = new SerializableHasher[seeds.length];
		outputs= new ObjectOutputStream[seeds.length];
		for(int i=0;i<seeds.length;i++) {
			hashes[i]  = (new SerializableHasher()).seed(seeds[i]);
			outputs[i] = new ObjectOutputStream(hashes[i]);
		}
	}
	
	
	public CountMinSketch(int width,int[] seeds) throws IOException {
		this.width = width;
		this.depth = seeds.length;
		m = new int[width*depth];
		initialize(m.length,seeds);
	}
	
	public Long increment(Object arg0,long amount) {
		int min = Integer.MAX_VALUE;
		for(int i=0;i<outputs.length;i++) {
			hashes[i].reset();
			try {
				outputs[i].writeObject(arg0);
				outputs[i].flush();
				int h = hashes[i].hash() % width;
				m[i*width + h] += amount;
				if(m[i*width + h] < min) min = m[i*width + h];
			} catch(IOException e) {
			}
		}		
		return (long) min;
	}
	
	public Long increment(Object arg0) { return increment(arg0,1); }
	
	public Long get(Object arg0) {
		return increment(arg0,0);
	}	
	
	public void clear() {
	}

	public boolean containsKey(Object arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean containsValue(Object arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	public Set<java.util.Map.Entry<E, Long>> entrySet() {
		// TODO Auto-generated method stub
		return null;
	}



	public boolean isEmpty() {
		// TODO Auto-generated method stub
		return false;
	}

	public Set<E> keySet() {
		// TODO Auto-generated method stub
		return null;
	}

	public Long put(E arg0, Long arg1) {
		// TODO Auto-generated method stub
		return null;
	}

	public void putAll(Map<? extends E, ? extends Long> arg0) {
		// TODO Auto-generated method stub
		
	}

	public Long remove(Object arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	public int size() {
		// TODO Auto-generated method stub
		return 0;
	}

	public Collection<Long> values() {
		// TODO Auto-generated method stub
		return null;
	}

	
	
}
