package wiley.realtime;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Collection;
import java.util.Iterator;
import java.util.Set;

import wiley.realtime.hash.SerializableHasher;

public class CountingBloomSet<E extends Serializable> implements Set<E> {

	byte[]               counters;
	int                  m,x;
	SerializableHasher[] hashes;
	ObjectOutputStream[] outputs;

	protected void initialize(int m,int[] seeds) throws IOException {
		this.m = m;
		hashes = new SerializableHasher[seeds.length];
		outputs= new ObjectOutputStream[seeds.length];
		for(int i=0;i<seeds.length;i++) {
			hashes[i]  = (new SerializableHasher()).seed(seeds[i]);
			outputs[i] = new ObjectOutputStream(hashes[i]);
		}
		counters = new byte[m];
	}
	
	public CountingBloomSet(int m,int[] seeds) throws IOException {
		initialize(m,seeds);
	}

	
	public boolean add(E arg0) {
		if(!contains(arg0)) {
			for(int i=0;i<outputs.length;i++) {
				hashes[i].reset();
				try {
					outputs[i].writeObject(arg0);
					outputs[i].flush();
					int j = hashes[i].hash() % m;
					if(counters[j] < Byte.MAX_VALUE) counters[j]++;
				} catch(IOException e) {
				}
			}
			return true;
		}
		return false;
	}

	public boolean addAll(Collection<? extends E> c) {
		// TODO Auto-generated method stub
		return false;
	}

	public void clear() {
		// TODO Auto-generated method stub
		
	}

	public boolean contains(Object o) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean containsAll(Collection<?> c) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isEmpty() {
		// TODO Auto-generated method stub
		return false;
	}

	public Iterator<E> iterator() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean remove(Object o) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean removeAll(Collection<?> c) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean retainAll(Collection<?> c) {
		// TODO Auto-generated method stub
		return false;
	}

	public int size() {
		double X = 0.0;
		for(int x : counters) if(x > 0) X += 1.0;
		return (int) (Math.log(1 - (double)X/(double)counters.length)/(Math.log(1.0 - 1.0/(double)counters.length)*(double)hashes.length));
	}

	public Object[] toArray() {
		// TODO Auto-generated method stub
		return null;
	}

	public <T> T[] toArray(T[] a) {
		// TODO Auto-generated method stub
		return null;
	}
	
}