package wiley.realtime;

import java.io.Serializable;
import java.util.PriorityQueue;

public class HeavyHitters<E extends Serializable> {
	
	CountMinSketch<E> sketch;
	PriorityQueue<E>  heap;
	double            f = 1.0;
	int               N = 0;
	
	public HeavyHitters(double f,CountMinSketch<E> sketch) {
		this.sketch = sketch;
		this.heap   = new PriorityQueue<E>(11,new SketchComparator<E>(sketch));
		this.f      = f;
	}

	public void add(E element) {
		N++;
		sketch.increment(element);
		heap.add(element);
		while(heap.size() > 0 && f <= (double)sketch.get(heap.peek())/(double)N) 
			heap.remove();
	}

}
