package wiley.realtime;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Collection;
import java.util.Iterator;
import java.util.Set;

import wiley.realtime.hash.SerializableHasher;

public class MinCount<E extends Serializable> implements Set<E> {

	int   b;
	int[]              M;
	SerializableHasher hash = new SerializableHasher();
	ObjectOutputStream out;
	
	public MinCount(int b) throws IOException {
		this.b = b;
		int m  = (int) Math.pow(2, b);
		this.M = new int[3*m];
		out    = new ObjectOutputStream(hash);
	}
	
	
	public boolean add(E arg0) {
		try {
			hash.reset();
			out.writeObject(arg0);
			out.flush();
			int h = hash.hash();
			
			int m = (h >>> (32-b));
			int v = (h << b) >>> b;
			
			if(M[m] > v) {
				M[m+2] = M[m+1];
				M[m]   = v;
			} else if(M[m+1] > v) {
				M[m+2] = M[m+1];
				M[m+1] = v;
			} else if(M[m+2] > v) {
				M[m+2] = v;
			}
			return true;
		} catch(IOException e) {
			return false;
		}
	}

	public boolean addAll(Collection<? extends E> arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	public void clear() {
		// TODO Auto-generated method stub
		
	}

	public boolean contains(Object arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean containsAll(Collection<?> arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isEmpty() {
		// TODO Auto-generated method stub
		return false;
	}

	public Iterator<E> iterator() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean remove(Object arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean removeAll(Collection<?> arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean retainAll(Collection<?> arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	public int size() {
		double range    = Math.pow(2,32-b);
		double estimate = 0.0;
		for(int i=0;i<M.length/3;i+=3)
			estimate += range/(double)M[i+2];
		return (int)(2.0*estimate);
	}
	
	public double distance(MinCount other) {
		double x = 0.0;
		for(int i=0;i<M.length;i++) {
			if(other.M[i] == M[i]) x += 1.0;
		}
		return x/(double)M.length;
	}
	

	public Object[] toArray() {
		return null;
	}

	public <T> T[] toArray(T[] arg0) {
		return null;
	}
	
}
