package wiley.realtime;

import java.io.IOException;
import java.io.Serializable;

import cern.jet.random.engine.MersenneTwister;

public class StableBloomSet<E extends Serializable> extends CountingBloomSet<E> {
	int d = 0;
	
	public StableBloomSet(int d,int m, int[] seeds) throws IOException {
		super(m,seeds);
		this.d = d;
	}
	
	private final MersenneTwister random = new MersenneTwister();	
	public void decrement() {
		int k = random.nextInt();
		for(int i=0;i<d;i++)
			if(counters[(k+i) % m] > 0) counters[(k+i) % m]--;
	}

	public boolean add(E arg0) {
		decrement();
		for(int i=0;i<outputs.length;i++) {
			hashes[i].reset();
			try {
				outputs[i].writeObject(arg0);
				outputs[i].flush();
				int j = hashes[i].hash() % m;
				counters[j] = Byte.MAX_VALUE;
			} catch(IOException e) {
			}
		}
		return true;
	}
	

}
