package wiley.realtime;

import java.io.Serializable;
import java.util.PriorityQueue;

public class TopList<E extends Serializable> {
	CountMinSketch<E> sketch;
	PriorityQueue<E>  heap;
	int               k       = Integer.MAX_VALUE;
	
	public TopList(int k,CountMinSketch<E> sketch) {
		this.sketch = sketch;
		this.k      = k;
		this.heap   = new PriorityQueue<E>(k+1,new SketchComparator<E>(sketch));
	}

	public void add(E element) {
		sketch.increment(element);
		heap.add(element);
		while(heap.size() > k) heap.remove();
	}

}
