package wiley.realtime.sampler;

import java.util.ArrayList;

import cern.jet.random.engine.MersenneTwister;

public class BiasedReservoir<E> {
	MersenneTwister rng = new MersenneTwister();
	ArrayList<E> reservoir = new ArrayList<E>();
	double rate;
	double size,N;
	
	public BiasedReservoir(double rate) {
		this.rate = rate;
		size      = Math.ceil(1.0/rate);
	}
	
	public void add(E obj) {
		if(rng.nextDouble() < ((double)reservoir.size())/size) {
			reservoir.remove(rng.nextInt() % reservoir.size());
		}
		reservoir.add(obj);
	}
	
	
}
