package wiley.realtime.sampler;

import cern.jet.random.engine.MersenneTwister;

public class Reservoir<E> {
	
	MersenneTwister rng = new MersenneTwister();
	Object[] reservoir;
	int      N;
	
	public Reservoir(int n) {
		super();
		reservoir = new Object[n];
		N         = 0;
	}

	public int total() { return N; }
	
	public boolean add(E arg0) {
		if(N < reservoir.length) {
			reservoir[N] = (Object)arg0;
		} else {
			long k = (long)Math.floor(N*rng.nextDouble());
			if(k < (long)reservoir.length) reservoir[(int)k] = (Object)arg0;
		}
		N++;
		return true;
	}



}
