package wiley.realtime.sampler;

import java.util.Arrays;

import cern.jet.random.engine.MersenneTwister;

public class SimpleRandomSample {
	static MersenneTwister rng = new MersenneTwister();	
	public static <E> E[] withReplacement(E[] in,int n) {
		Object[]     sample = new Object[n];
		for(int i=0;i<n;i++)
			sample[i] = in[(int)Math.floor(n*rng.nextInt())];
		return (E[])sample;
	}
	
	public static <E> void permute(E[] array) {
		for(int i=0;i<array.length;i++) {
			int j = i + (int)Math.floor((array.length - i)*rng.nextDouble());
			E temp = array[i];array[i] = array[j];array[j] = temp;
		}
	}
	
	public static <E> E[] withoutReplacement(E[] array,int n) {
		for(int i=0;i<n;i++) {
			int j = i + (int)Math.floor((array.length - i)*rng.nextDouble());
			E temp = array[i];array[i] = array[j];array[j] = temp;
		}
		return Arrays.copyOf(array, n);
	}
	
	public static <E> void durstenfeldPermute(E[] array) {
		for(int i=array.length-1;i>0;i--) {
			int j = (int)Math.floor(i*rng.nextDouble());
			E temp = array[i];array[i] = array[j];array[j] = temp;
		}
	}
	
}
