package wiley.realtime.sampler;

import java.util.LinkedList;
import java.util.concurrent.LinkedBlockingQueue;

public class SlidingWindow<E> {
	int n,k,max;
	int last = Integer.MAX_VALUE;
	
	public SlidingWindow(int n,int k,int max) {
		this.n = n;this.k = k;this.max = max;
	}
	
	LinkedBlockingQueue<Reservoir<E>> completed = new LinkedBlockingQueue<Reservoir<E>>();
	LinkedList<Reservoir<E>> live      = new LinkedList<Reservoir<E>>();
	
	
	public Reservoir<E> next() { return completed.poll(); }
	
	public void add(E object) {
		if(last >= this.k) {
			last = 0;
			live.add(new Reservoir<E>(n));
		}
		while(live.peek() != null && live.peek().total() >= max)
			completed.add(live.poll());
		for(Reservoir<E> e : live) e.add(object);
		last++;
	}
	
}
