package wiley.samza;

import java.util.HashMap;
import java.util.Map;

import org.apache.samza.config.Config;
import org.apache.samza.system.IncomingMessageEnvelope;
import org.apache.samza.system.OutgoingMessageEnvelope;
import org.apache.samza.system.SystemStream;
import org.apache.samza.task.InitableTask;
import org.apache.samza.task.MessageCollector;
import org.apache.samza.task.StreamTask;
import org.apache.samza.task.TaskContext;
import org.apache.samza.task.TaskCoordinator;
import org.apache.samza.task.WindowableTask;

public class SimpleCountingJob implements WindowableTask, StreamTask, InitableTask {
	
	String       field = "field";
	SystemStream output;
	HashMap<String,Integer> counts = new HashMap<String,Integer>();
	
	public void process(IncomingMessageEnvelope msg, MessageCollector collector,
			TaskCoordinator coordinator) throws Exception {

		@SuppressWarnings("unchecked")
		Map<String,Object> obj = (Map<String,Object>)msg.getMessage();
		
		String key = obj.get(field).toString();
		Integer current = counts.get(key);
		
		counts.put(key, 1 + (current == null ? 0 : current));
		
	}

	public void window(MessageCollector collector, TaskCoordinator coordinator)
			throws Exception {
		collector.send(new OutgoingMessageEnvelope(output,counts));
		counts = new HashMap<String,Integer>();
	}

	public void init(Config config, TaskContext context) throws Exception {
		field  = config.get("count.field", "field");
		output = new SystemStream("kafka",config.get("count.output","stats"));
	}

}
