package wiley.storm.trident;

import storm.trident.TridentTopology;
import storm.trident.operation.builtin.Count;
import storm.trident.testing.MemoryMapState;
import backtype.storm.generated.StormTopology;
import backtype.storm.tuple.Fields;
import wiley.storm.TopologyDefinition;
import wiley.storm.util.JSONToTuple;
import wiley.storm.util.PostFilter;

public class TrivialEventCounter implements TopologyDefinition {

	public StormTopology topology(String[] args) {
		TridentTopology topology = new TridentTopology();
		topology.newStream("input", SimpleKafkaSpout.spout().configure(args))
			.aggregate(new Count(), new Fields("count"))
			.each(new Fields("count"), new PostFilter());
		;
		return topology.build();
	}

}
